"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileLoader = void 0;
const promises_1 = require("fs/promises");
const js_yaml_1 = __importDefault(require("js-yaml"));
const resolvePath = (path, against) => {
    console.log('resolving path: ' + path, 'against', against);
    return path;
};
const valueOrArrayElement = (value) => {
    if (Array.isArray(value) && value.length)
        return value[0];
    if (Array.isArray(value) && !value.length)
        return null;
    return value;
};
class FileLoader {
    path;
    constructor(path) {
        this.path = path;
    }
    async load() {
        const indexSchemaContent = await (0, promises_1.readFile)(this.path, 'utf-8');
        return valueOrArrayElement(js_yaml_1.default.loadAll(indexSchemaContent));
    }
    async readPortion(file, cb) {
        if (file.url.includes('json-schema-ref-parser/dist/')) {
            const realPath = resolvePath(file.url.split('json-schema-ref-parser/dist/')[1], __dirname);
            const res = await (0, promises_1.readFile)(realPath, 'utf-8');
            cb(undefined, res);
            return res;
        }
        const res = (0, promises_1.readFile)(file.url, 'utf-8');
        cb(undefined, res);
        return res;
    }
}
exports.FileLoader = FileLoader;
