"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SchemaParser = void 0;
const json_schema_ref_parser_1 = __importDefault(require("@apidevtools/json-schema-ref-parser"));
class SchemaParser {
    schemaObject;
    schemaLoader;
    constructor(schemaObject, schemaLoader) {
        this.schemaObject = schemaObject;
        this.schemaLoader = schemaLoader;
    }
    async parse() {
        const fullSchemaArr = (await json_schema_ref_parser_1.default.dereference(this.schemaObject, {
            continueOnError: false,
            parse: {
                json: false,
                yaml: {
                    allowEmpty: false,
                },
            },
            resolve: {
                file: {
                    read: this.schemaLoader.readPortion,
                },
            },
            dereference: {
            // circular: true,
            },
        }));
        return fullSchemaArr;
    }
}
exports.SchemaParser = SchemaParser;
