import type { OpenAPIV3 } from 'openapi-types';
import { SourceFile } from 'ts-morph';
import { FlatOperation, ImportData } from './types';
declare enum HttpMethod {
    GET = "get",
    PUT = "put",
    POST = "post",
    DELETE = "delete",
    OPTIONS = "options",
    HEAD = "head",
    PATCH = "patch",
    TRACE = "trace"
}
export declare const SEARCH_OPCODES: string[];
export declare const parseOpcode: (operation: OpenAPIV3.OperationObject | FlatOperation) => string;
export declare const isOperationMutation: (method: HttpMethod, operation: OpenAPIV3.OperationObject | FlatOperation) => boolean;
export declare const flattenPaths: (paths: OpenAPIV3.PathsObject) => FlatOperation[];
export declare const removeLeadingSlash: (path: string) => string;
export declare const groupOperations: (flatOperation: FlatOperation[]) => Record<string, FlatOperation[]>;
export declare const renderImports: (sourceFile: SourceFile, imports: ImportData[]) => void;
export declare const hasPathParams: (op: FlatOperation) => boolean;
export declare const hasFileUpload: (op: FlatOperation) => boolean;
export declare const extractOperationTypeNames: (operation: FlatOperation) => {
    request: string | null;
    response: string;
    responseData: string;
    responseMeta: string;
};
export {};
//# sourceMappingURL=helpers.d.ts.map